/*
 * $Id: fukuro.c,v 1.1.1.1 2002/10/19 13:07:02 kenta Exp $
 *
 * Copyright 2002 Kenta Cho. All rights reserved.
 */

/**
 * Fukuro bootstrap.
 *
 * @version $Revision: 1.1.1.1 $
 */
#include <string.h>
#include <stdlib.h>
#include <piece.h>
//#include "piece2sdl.h"

#include "fukuro.h"
#include "fukuroengine.h"
#include "hero.h"
#include "media.h"
#include "degutil.h"

int status;
int cnt = 0;
static unsigned long bgmCount;

static void initDemo() {
  status = DEMO; cnt = -1;
  initFukuro();
  initHero();
}

static void initInGame() {
  status = IN_GAME; cnt = -1;
  initFukuro();
  initHero();
  //playSeNow(SE_BGM, 0, -1);
  bgmCount = 0;
}

void initGameover() {
  status = GAME_OVER; cnt = -1;
  stopSeNow(0);
}

#define INTERVAL 30

void pceAppInit() {
  // Randomize.
  PCETIME time;
  pceTimeGet(&time);
  srand(time.s100 + time.ss*100);

  // No pad auto repeat.
  while(pcePadGet()) pcePadGetProc();
  pcePadSetTrigMode(PP_MODE_SINGLE);

  pceLCDDispStop();
  pceLCDSetBuffer(vbuf);

  saveWaveAtt();

  initScreen();
  initSound();

  initDegutil();

  initDemo();

  pceAppSetProcPeriod(INTERVAL);
  pceLCDDispStart();
}

void pceAppProc(int c) {
  DRAW_OBJECT obj;
  int pad = pcePadGet();

  // Play SE/BGM at this timing.
  unsigned long tc = pceTimerGetCount();
  if ( status == IN_GAME && tc-bgmCount > INTERVAL*66+INTERVAL/4 ) {
    playSeNow(SE_BGM, 0, 0);
    bgmCount = tc;
  }

  cnt++;

  clearScreen();

  switch ( status ) {
  case DEMO:
    // Start game when TRG_C(start) is pressed.
    if ( pad & TRG_C ) {
      initInGame();
      return;
    }
    moveFukuro();
    if ( (cnt & 127) == 0 ) {
      setHeroRandomPos();
    }
    pceLCDSetObject(&obj, &titleBmp, 32, 38, 0, 0, 64, 12, DRW_NOMAL);
    pceLCDDrawObject(obj);
    drawFukuro();
    break;
  case IN_GAME:
    moveFukuro();
    moveHero(pad);
    drawFukuro();
    drawHero();
    drawScore();
    break;
  case GAME_OVER:
    if ( cnt < 40 ) {
      drawDeadHero(cnt);
    } else {
      moveFukuro();
      drawFukuro();
      drawDeadHero(40);
      drawScore();
      if ( cnt > 360 || (pad & (TRG_A | TRG_B | TRG_C)) ) {
	initDemo();
      }
    }
    break;
  }

  // Exit application when TRG_D(select) is pressed.
  if ( pad & TRG_D ) {
    pceAppReqExit(1);
  }
  pceLCDTrans();
}

void pceAppExit( void ) {
  stopSe();
  loadWaveAtt();
}
