/*
 * $Id: fukuroengine.h,v 1.1.1.1 2002/10/19 13:07:02 kenta Exp $
 *
 * Copyright 2002 Kenta Cho. All rights reserved.
 */

/**
 * Fukuro engine header file.
 *
 * @version $Revision: 1.1.1.1 $
 */
#define FIELD_DOT_WIDTH 128
#define FIELD_DOT_HEIGHT 88

#define FIELD_WIDTH (FIELD_DOT_WIDTH*512)
#define FIELD_HEIGHT (FIELD_DOT_HEIGHT*512)

#define VAGABOND_MAX 64
#define NOT_EXIST -99999

typedef struct {
  int x, y;
  int mx, my;
  int d, r;
  int walkCnt;
  int punchCnt;
  int bmx, bmy, blowCnt;
} Vagabond;

typedef struct {
  int x, y;
  int d;
  int walkCnt;
  int mx, my;
  int punchCnt;
  int damage;
  int bmx, bmy;
} Hero;

extern Vagabond vagabond[];
extern Hero hero;

void initFukuro();
void moveFukuro();
int checkPunchHitVagabond(int x, int y);
void drawFukuro();
