/*
 * $Id: media.c,v 1.1.1.1 2002/10/19 13:07:02 kenta Exp $
 *
 * Copyright 2002 Kenta Cho. All rights reserved.
 */

/**
 * Screen/Sound for P/ECE.
 *
 * @version $Revision: 1.1.1.1 $
 */
#include <string.h>
#include <stdlib.h>
#include <piece.h>
//#include "piece2sdl.h"

#include "media.h"

PIECE_BMP titleBmp;

unsigned char vbuf[SCREEN_WIDTH*SCREEN_HEIGHT];

static void loadBmp(unsigned char *data, PIECE_BMP *bmp) {
  PBMP_FILEHEADER pbhead;
  memcpy(&pbhead, data, sizeof(PBMP_FILEHEADER));
  bmp->header = pbhead;
  bmp->buf  = data + sizeof(PBMP_FILEHEADER);
  bmp->mask = data + sizeof(PBMP_FILEHEADER) + (bmp->header.h*bmp->header.w)/4;
}

void initScreen() {
  loadBmp(IMG_TITLE, &titleBmp);
}

void clearScreen() {
  memset(vbuf, 0, SCREEN_WIDTH*SCREEN_HEIGHT);
}

void drawLine(int c, int x1, int y1, int x2, int y2) {
  if ( x1 < x2 ) {
    if ( x1 < 0 ) {
      if ( x2 < 0 ) return;
      y1 = (y2-y1)*-x1/(x2-x1) + y1;
      x1 = 0;
    }
    if ( x2 >= SCREEN_WIDTH ) {
      if ( x1 >= SCREEN_WIDTH ) return;
      y2 = (y1-y2)*(SCREEN_WIDTH-x2)/(x1-x2) + y2;
      x2 = SCREEN_WIDTH-1;
    }
  } else {
    if ( x2 < 0 ) {
      if ( x1 < 0 ) return;
      y2 = (y1-y2)*-x2/(x1-x2) + y2;
      x2 = 0;
    }
    if ( x1 >= SCREEN_WIDTH ) {
      if ( x2 >= SCREEN_WIDTH ) return;
      y1 = (y2-y1)*(SCREEN_WIDTH-x1)/(x2-x1) + y1;
      x1 = SCREEN_WIDTH-1;
    }
  }
  if ( y1 < y2 ) {
    if ( y1 < 0 ) {
      if ( y2 < 0 ) return;
      x1 = (x2-x1)*-y1/(y2-y1) + x1;
      y1 = 0;
    }
    if ( y2 >= SCREEN_HEIGHT ) {
      if ( y1 >= SCREEN_HEIGHT ) return;
      x2 = (x1-x2)*(SCREEN_HEIGHT-y2)/(y1-y2) + x2;
      y2 = SCREEN_HEIGHT-1;
    }
  } else {
    if ( y2 < 0 ) {
      if ( y1 < 0 ) return;
      x2 = (x1-x2)*-y2/(y1-y2) + x2;
      y2 = 0;
    }
    if ( y1 >= SCREEN_HEIGHT ) {
      if ( y2 >= SCREEN_HEIGHT ) return;
      x1 = (x2-x1)*(SCREEN_HEIGHT-y1)/(y2-y1) + x1;
      y1 = SCREEN_HEIGHT-1;
    }
  }
  pceLCDLine(c, x1, y1, x2, y2);
}

// Handle sounds.

static PCEWAVEINFO wtemp;
static int prvAtt[4];

void initSound() {
  int i;
  for ( i=0 ; i<4 ; i++ ) {
    pceWaveSetChAtt(i, 8);
  }
}

void playSeNow(char *snd, int ch, int loop) {
  wtemp = *((PCEWAVEINFO*)(snd + 8));
  wtemp.pData = snd + 8 + sizeof(PCEWAVEINFO);
  pceWaveDataOut(ch, &wtemp);
}

void stopSeNow(int ch) {
  pceWaveAbort(ch);
}

void stopSe() {
  int i;
  for ( i=0 ; i<4 ; i++ ) {
    pceWaveAbort(i);
  }
}

void saveWaveAtt() {
  int i;
  for ( i=0 ; i<4 ; i++ ) {
    prvAtt[i] = pceWaveSetChAtt(i, INVALIDVAL);
  }
}

void loadWaveAtt() {
  int i;
  for ( i=0 ; i<4 ; i++ ) {
    pceWaveSetChAtt(i, prvAtt[i]);
  }
}
